package tavi;

import junit.framework.*;
import junit.swingui.*;

import tavi.graph.*;

/**
 * Standard top-level TestSuite under which all JUnit tests (and sub suites)
 * are collected. This class contains only static methods and no instances
 * are meant to be created.
 *
 * @version     0.0.1 25 Feb 2002
 */
public abstract class AllTests {
    /**
     * Constructor is not used.
     */
    private AllTests() {
	;
    }

    /**
     * Standard method that enables tests to be run from command line.
     * Type: "java AllTests". 
     */
    public static void main(String[] args) {
        junit.textui.TestRunner.run (suite());
	System.exit(0);
    }
    /**
     * Build suite from test classes.
     * @return the collection of test classes.
     */
    public static Test suite() {
	TestSuite suite = new TestSuite("All Tests");
	suite.addTestSuite(TFlowTest.class);
	suite.addTestSuite(GraphTest.class);
	suite.addTestSuite(ServerTest.class);
	suite.addTestSuite(IdentifierTest.class);
	return suite;
    }
}









