/* 
 * @(#)IdentifierTest 28.2.2002 version 0.1.1 
 * 
 * Copyright University of Helsinki / Department of computer science 
 * 
 */ 

package tavi.graph;

import junit.framework.*;

/** 
 * JUnit test-class for Identifier.java. 
 * 
 * @version     0.1.1 28 Feb 2002 
 * @author      Johannes Ukkonen
 */ 
public class IdentifierTest extends TestCase {
    ; 

    /**
     * Standard JUnit testfile constructor.
     * @param name Name of the test (should always supply the name of the
     *        class as per JUnit doctrine).
     */
    public IdentifierTest(String name) {
        super(name);
    }

    /**
     * Standard JUnit command line launcher. Allows GraphTest to be 
     * executed independently from command line, type 'java IdentifierTest'.
     * @param args[] Required in main method. Not used.
     */
    public static void main(String[] args) {
        junit.swingui.TestRunner.run(IdentifierTest.class);
    }

    /**
     * Automatically executed before every test. Common testcase 
     * initialization should be put here.
     */
    protected void setUp() {
	;
    }

    /**
     * Complement of setUp(). Common testcase zeroeing should be 
     * put here 
     */
    protected void tearDown() {
        ;
    }

    /**
     * Tests method getIdentifier().
     */
    public void testGetIdentifier() {
	Identifier i = new Identifier();
	assertTrue("aa".equals(i.getIdentifier()));
	assertTrue("ab".equals(i.getIdentifier()));
	assertTrue("ac".equals(i.getIdentifier()));
	i.releaseIdentifier("ab");
	assertTrue("ab".equals(i.getIdentifier()));
	assertTrue("ad".equals(i.getIdentifier()));
	i.releaseIdentifier("ab");
	i.releaseIdentifier("ab");	
    }
    
    /**
     * Tests method releaseIdentifier.
     */
    public void testReleaseIdentifier() {
	Identifier i = new Identifier();
	i.releaseIdentifier("B");
	assertTrue("aa".equals(i.getIdentifier()));
	i.releaseIdentifier("E");
	assertTrue("ab".equals(i.getIdentifier()));
	i.releaseIdentifier("");
	assertTrue("ac".equals(i.getIdentifier()));
	i.releaseIdentifier("ab");
	assertTrue("ab".equals(i.getIdentifier()));
    }

    /**
     * Tests method getNumber().
     */
    public void testGetNumber() {
	Identifier i = new Identifier();
	assertTrue(0 == i.getNumber());
	assertTrue(1 == i.getNumber());
	assertTrue(2 == i.getNumber());
	i.releaseNumber(1);
	assertTrue(1 == i.getNumber());
	assertTrue(3 == i.getNumber());
	i.releaseNumber(2);
	i.releaseNumber(2);
    }

    /**
     * Tests the transaction identifier assignment.
     */
    public void testGetTransactionId() {
	Identifier i = new Identifier();
	assertTrue(i.getTransactionId().equals("Tr1"));
	assertTrue(i.getTransactionId().equals("Tr2"));
	i.releaseTransactionId("Tr1");
	assertTrue(i.getTransactionId().equals("Tr1"));
    }

    /**
     * Tests the releasing of transaction identifiers.
     */
    public void testReleaseTransactionId() {
	Identifier id = new Identifier();
	id.getTransactionId();
	id.getTransactionId();
	id.releaseTransactionId("Tr0");
	assertTrue(id.getTransactionId().equals("Tr0"));
	id.releaseTransactionId("Tr1");
	assertTrue(id.getTransactionId().equals("Tr1"));
    }
}





